#include <stdio.h>

// == Global data =============================================================

#define W  * 4
#define KB * 1024
#define MB KB KB

#define DATA_SZ   8 MB
#define HEAP_SZ  16 MB
#define STACK_SZ 16 MB

union {
  int mem[0];
  struct {
    int m_display[0];		// data label for "display"
    int a_0001;
    int a_0002;
    int a_0003;
    int m_htop[0];		// data label for "htop"
    int a_0004;
    int m_heap[0];		// data label for "heap"
  } named;
  struct {
    int z_data[DATA_SZ];
    int z_heap[HEAP_SZ];
    int z_stack[STACK_SZ];
  } zone;
} global;

#define MEM   global.mem
#define DATA  global.zone.z_data
#define HEAP  global.zone.z_heap
#define STACK global.zone.z_stack

int *SP = STACK+STACK_SZ;
int *FP = 0;
int  SR;
void *PC;				// (unused)

// -- Names for global variables ----------------------------------------------

#define GV_display ((int *) &global.named.m_display - (int *) &global.named)
#define GV_htop ((int *) &global.named.m_htop - (int *) &global.named)
#define GV_heap ((int *) &global.named.m_heap - (int *) &global.named)

// == Program =================================================================

int main (int argc, char *argv[])
{
  int i;

// -- Initialization ----------------------------------------------------------
  global.named.a_0001 = 0;
  global.named.a_0002 = 0;
  global.named.a_0003 = 0;
  global.named.a_0004 = GV_heap;

// -- Library -----------------------------------------------------------------

	goto lib_init;			// skip library code!

print_int:				// print_int (int) -> ()
	printf ("%d\n", SP[1]);
	goto * ((void *) *SP++);

print_char:				// print_char (int) -> ()
	putchar (SP[1]);
	goto * ((void *) *SP++);

read_int:				// read_int () -> int
	scanf ("%d", &SP[1]);
	goto * ((void *) *SP++);

read_char:				// read_char () -> int
	SP[1] = getchar ();
	goto * ((void *) *SP++);

halt:					// halt () -> ()
	return 0;

dump_regs:				// dump_regs () -> ()
	{
	  printf ("-- Register dump --\n");
	  printf ("SP = 0x%x (%d)\n", (int) SP, (int) SP);
	  printf ("FP = 0x%x (%d)\n", (int) FP, (int) FP);
	  printf ("SR = 0x%x (%d)\n", (int) SR, (int) SR);
	  printf ("PC = (unused)\n");
	}
	goto * ((void *) *SP++);

dump_stack:				// dump_stack () -> ()
	{
	  printf ("-- Stack dump --\n");
	}
	goto * ((void *) *SP++);

stack_trace:				// stack_trace () -> ()
	{
	  printf ("-- Stack trace --\n");
	}
	goto * ((void *) *SP++);

lib_init:
	{
	  // (declarations for function ) (print_int);
	  // (declarations for function ) (print_char);
	  // (declarations for function ) (read_int);
	  // (declarations for function ) (read_char);
	  // (declarations for function ) (halt);
	  // (declarations for function ) (dump_regs);
	  // (declarations for function ) (dump_stack);
	  // (declarations for function ) (stack_trace);
	}

// -- Start execution ---------------------------------------------------------
  *--SP = (int) &&L_exit_program; // Save return address for main program
  goto program;			// start kicking...
L_exit_program:			// Return here, and...
  exit (0);			// quit.
  

// -- Instructions ------------------------------------------------------------
	*--SP = (int) &&_let_0;		// PUSH _let_0
	goto * ((void *)*SP++);		// JUMP
nfactor_1:
	*--SP = 4;		// PUSH 4
	{ int N = *SP; MEM[*SP]=(int) FP; FP=SP; SP -= N; } // LINK
	*--SP = GV_display;		// PUSH display
	*--SP = 8;		// PUSH 8
	SP[1] = SP[1] + SP[0]; ++SP;	// ADD
	SP[-1] = *SP; --SP;		// DUP
	SP[0] = MEM[(int) SP[0]];	// LOAD
	*--SP = -4;		// PUSH -4
	*SP = *SP + (int) FP;		// LOCAL
	MEM[(int) SP[0]] = SP[1]; ++SP;	// STORE
	*--SP = 0;		// PUSH 0
	*SP = *SP + (int) FP;		// LOCAL
	SP[-1] = *SP; *SP = SP[1]; SP[1]=SP[-1]; // SWAP
	MEM[(int) SP[0]] = SP[1]; ++SP;	// STORE
	*--SP = (int) &&_then_1;		// PUSH _then_1
	*--SP = (int) &&_neq_3;		// PUSH _neq_3
	*--SP = 12;		// PUSH 12
	*SP = *SP + (int) FP;		// LOCAL
	SP[0] = MEM[(int) SP[0]];	// LOAD
	*--SP = 0;		// PUSH 0
	SP[1] = SP[1] - SP[0]; ++SP;	// SUB
	if (! *SP++) goto P_26;		// SKIPZ
	goto * ((void *)*SP++);		// JUMP
P_26:	++SP;				// POP
	*--SP = 1;		// PUSH 1
	*--SP = (int) &&_fimeq_4;		// PUSH _fimeq_4
	goto * ((void *)*SP++);		// JUMP
_neq_3:
	*--SP = 0;		// PUSH 0
_fimeq_4:
	if (! *SP++) goto P_33;		// SKIPZ
	goto * ((void *)*SP++);		// JUMP
P_33:	++SP;				// POP
	*--SP = 12;		// PUSH 12
	*SP = *SP + (int) FP;		// LOCAL
	SP[0] = MEM[(int) SP[0]];	// LOAD
	*--SP = 12;		// PUSH 12
	*SP = *SP + (int) FP;		// LOCAL
	SP[0] = MEM[(int) SP[0]];	// LOAD
	*--SP = 1;		// PUSH 1
	SP[1] = SP[1] - SP[0]; ++SP;	// SUB
	SP[-1] = *SP; --SP;		// DUP
	*--SP = (int) &&nfactor_1;		// PUSH nfactor_1
	{ void *C = (void *) *SP; *SP=(int)&&P_45; goto *C; } // CALL
P_45:	SP[-1] = *SP; *SP = SP[1]; SP[1]=SP[-1]; // SWAP
	++SP;				// POP
	SP[1] = SP[1] * SP[0]; ++SP;	// MUL
	*--SP = (int) &&_fimif_2;		// PUSH _fimif_2
	goto * ((void *)*SP++);		// JUMP
_then_1:
	*--SP = 1;		// PUSH 1
_fimif_2:
	*--SP = 8;		// PUSH 8
	*SP = *SP + (int) FP;		// LOCAL
	MEM[(int) SP[0]] = SP[1]; ++SP;	// STORE
	*--SP = -4;		// PUSH -4
	*SP = *SP + (int) FP;		// LOCAL
	SP[0] = MEM[(int) SP[0]];	// LOAD
	*--SP = GV_display;		// PUSH display
	*--SP = 8;		// PUSH 8
	SP[1] = SP[1] + SP[0]; ++SP;	// ADD
	MEM[(int) SP[0]] = SP[1]; ++SP;	// STORE
	SP=FP; FP=(int *)MEM[*SP++];	// UNLINK
	goto * ((void *)*SP++);		// JUMP
_let_0:
	*--SP = 0;		// PUSH 0
	*--SP = 4;		// PUSH 4
	{ int N = *SP; MEM[*SP]=(int) FP; FP=SP; SP -= N; } // LINK
	*--SP = GV_display;		// PUSH display
	*--SP = 4;		// PUSH 4
	SP[1] = SP[1] + SP[0]; ++SP;	// ADD
	SP[-1] = *SP; --SP;		// DUP
	SP[0] = MEM[(int) SP[0]];	// LOAD
	*--SP = -4;		// PUSH -4
	*SP = *SP + (int) FP;		// LOCAL
	MEM[(int) SP[0]] = SP[1]; ++SP;	// STORE
	*--SP = 0;		// PUSH 0
	*SP = *SP + (int) FP;		// LOCAL
	SP[-1] = *SP; *SP = SP[1]; SP[1]=SP[-1]; // SWAP
	MEM[(int) SP[0]] = SP[1]; ++SP;	// STORE
	*--SP = 10;		// PUSH 10
	SP[-1] = *SP; --SP;		// DUP
	*--SP = (int) &&nfactor_1;		// PUSH nfactor_1
	{ void *C = (void *) *SP; *SP=(int)&&P_82; goto *C; } // CALL
P_82:	SP[-1] = *SP; *SP = SP[1]; SP[1]=SP[-1]; // SWAP
	++SP;				// POP
	*--SP = 4;		// PUSH 4
	*SP = *SP + (int) FP;		// LOCAL
	MEM[(int) SP[0]] = SP[1]; ++SP;	// STORE
	*--SP = -4;		// PUSH -4
	*SP = *SP + (int) FP;		// LOCAL
	SP[0] = MEM[(int) SP[0]];	// LOAD
	*--SP = GV_display;		// PUSH display
	*--SP = 4;		// PUSH 4
	SP[1] = SP[1] + SP[0]; ++SP;	// ADD
	MEM[(int) SP[0]] = SP[1]; ++SP;	// STORE
	SP=FP; FP=(int *)MEM[*SP++];	// UNLINK

}

